=== debian/changelog ===
pgagroal (1.5.0-2) unstable; urgency=medium

  * Add -latomic for armel/mipsel/powerpc/riscv64.

 -- Christoph Berg <myon@debian.org>  Thu, 24 Nov 2022 10:38:58 +0100

pgagroal (1.5.0-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Wed, 23 Nov 2022 16:34:19 +0100
