=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_BUILD_RPATH=TRUE

override_dh_installsystemd:
	# only enable the socket, not the service
	dh_installsystemd pgagroal.socket

%:
	dh $@ --buildsystem cmake
