## pgagroal 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 set(VERSION_MAJOR "1")
 set(VERSION_MINOR "5")
-set(VERSION_PATCH "0")
+set(VERSION_PATCH "1")
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 #
@@ -78,6 +78,13 @@
 endif()
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
+  find_package(Libatomic)
+  if (LIBATOMIC_FOUND)
+    message(STATUS "libatomic found")
+  else ()
+    message(FATAL_ERROR "libatomic needed")
+  endif()
+
   find_package(Systemd)
   if (SYSTEMD_FOUND)
     message(STATUS "systemd found")
