=== src/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,7 @@
     ${OPENSSL_CRYPTO_LIBRARY}
     ${OPENSSL_SSL_LIBRARY}
     ${SYSTEMD_LIBRARIES}
+    ${LIBATOMIC_LIBRARY}
   )
 
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
