=== debian/changelog ===
pgagroal (1.5.1-3.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Thu, 23 Nov 2023 16:45:54 +0000

pgagroal (1.5.1-3) unstable; urgency=medium

  * Install systemd units using dh_installsystemd.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Nov 2023 16:45:54 +0000

pgagroal (1.5.1-2) unstable; urgency=medium

  * Fix PG protocol on big-endian machines. (Closes: #1031011)
  * Use larger buffer for protocol messages.

 -- Christoph Berg <myon@debian.org>  Wed, 06 Sep 2023 15:27:20 +0000

pgagroal (1.5.1-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Sat, 13 May 2023 09:45:13 +0200
