=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Christoph Berg <myon@debian.org>,
 Build-Depends:
  cmake (>= 3.14.0),
- debhelper-compat (= 13),
+ debhelper (>= 12),
  libev-dev,
  libssl-dev,
  libsystemd-dev,
