=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,7 @@
     ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIR}
     ${SYSTEMD_INCLUDE_DIRS}
+    ${CJSON_INCLUDE_DIRS}
   )
 
   #
@@ -33,10 +34,54 @@
     ${OPENSSL_SSL_LIBRARY}
     ${SYSTEMD_LIBRARIES}
     ${LIBATOMIC_LIBRARY}
+    ${CJSON_LIBRARIES}
   )
 
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
-
+elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
+  find_program(HOMEBREW_EXECUTABLE brew)
+  if(EXISTS ${HOMEBREW_EXECUTABLE})
+    execute_process(
+      COMMAND ${HOMEBREW_EXECUTABLE} --prefix
+      OUTPUT_VARIABLE HOMEBREW_PREFIX
+      OUTPUT_STRIP_TRAILING_WHITESPACE)
+    message(STATUS "Homebrew found at ${HOMEBREW_PREFIX}")
+  endif()
+
+  #
+  # Detecting OpenSSL
+  #
+  execute_process(
+    COMMAND ${HOMEBREW_EXECUTABLE} --prefix openssl
+    OUTPUT_VARIABLE HOMEBREW_OPENSSL
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if(DEFINED HOMEBREW_OPENSSL)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -I${HOMEBREW_OPENSSL}/include")
+  else()
+    message(FATAL_ERROR "Homebrew's OpenSSL needed")
+  endif()
+
+  add_compile_options(-D_DARWIN_C_SOURCE)
+  add_compile_options(-DHAVE_OSX)
+
+  #
+  # Include directories
+  #
+  include_directories(
+    ${CMAKE_CURRENT_SOURCE_DIR}/include
+    ${LIBEV_INCLUDE_DIRS}
+    ${OPENSSL_INCLUDE_DIRS}
+    ${CJSON_INCLUDE_DIRS}
+  )
+
+  #
+  # Library directories
+  #
+  link_libraries(
+    ${LIBEV_LIBRARIES}
+    ${OPENSSL_LIBRARIES}
+    ${CJSON_LIBRARIES}
+  )
 else()
 
   add_compile_options(-D_XOPEN_SOURCE=700)
@@ -57,6 +102,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/include
     ${LIBEV_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIRS}
+    ${CJSON_INCLUDE_DIRS}
   )
 
   #
@@ -65,6 +111,7 @@
   link_libraries(
     ${LIBEV_LIBRARIES}
     ${OPENSSL_LIBRARIES}
+    ${CJSON_LIBRARIES}
   )
 endif()
 
@@ -73,6 +120,7 @@
 #
 add_compile_options(-g)
 add_compile_options(-Wall)
+add_compile_options(-Werror)
 add_compile_options(-std=c17)
 add_compile_options(-D__USE_ISOC11)
 add_compile_options(-D_GNU_SOURCE)
@@ -136,14 +184,15 @@
     endif()
   endif()
 
-  check_c_compiler_flag(-Wl,-z,relro HAS_RELRO)
-  if (HAS_RELRO)
+  check_c_compiler_flag(-Wl,arg HAS_LINKER)
+  check_linker_flag(C "-z relro" LINKER_HAS_RELRO)
+  if (HAS_LINKER AND LINKER_HAS_RELRO)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
   endif()
 
-  check_c_compiler_flag(-Wl,-z,now HAS_NOW)
-  if (HAS_NOW)
+  check_linker_flag(C "-z now" LINKER_HAS_NOW)
+  if (HAS_LINKER AND LINKER_HAS_NOW)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
   endif()
@@ -198,14 +247,15 @@
     endif()
   endif()
 
-  check_c_compiler_flag(-Wl,-z,relro HAS_RELRO)
-  if (HAS_RELRO)
+  check_c_compiler_flag(-Wl,arg HAS_LINKER)
+  check_linker_flag(C "-z relro" LINKER_HAS_RELRO)
+  if (HAS_LINKER AND HAS_RELRO)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
   endif()
 
-  check_c_compiler_flag(-Wl,-z,now HAS_NOW)
-  if (HAS_NOW)
+  check_linker_flag(C "-z now" LINKER_HAS_NOW)
+  if (HAS_LINKER AND LINKER_HAS_NOW)
     set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
     set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
   endif()
@@ -270,3 +320,4 @@
 target_link_libraries(pgagroal-admin-bin pgagroal)
 
 install(TARGETS pgagroal-admin-bin DESTINATION ${CMAKE_INSTALL_BINDIR})
+
