=== debian/changelog ===
pgagroal (1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0.

 -- Christoph Berg <myon@debian.org>  Fri, 23 Feb 2024 15:38:54 +0100
