=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
  Christoph Berg <myon@debian.org>,
 Build-Depends:
  cmake (>= 3.14.0),
- debhelper (>= 12),
+ debhelper-compat (= 13),
+ libcjson-dev,
  libev-dev,
  libssl-dev,
  libsystemd-dev,
