=== debian/watch ===
version=4
https://github.com/agroal/pgagroal/tags .*/(.*).tar.gz
