## pgagroal 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.14.0)
 
-set(VERSION_MAJOR "1")
-set(VERSION_MINOR "6")
+set(VERSION_MAJOR "2")
+set(VERSION_MINOR "0")
 set(VERSION_PATCH "0")
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
@@ -16,6 +16,12 @@
 endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
 
 project(pgagroal VERSION ${VERSION_STRING} LANGUAGES  C)
+
+if (NOT DEFINED DOCS)
+  set(DOCS TRUE)
+endif()
+include(CTest)
+enable_testing()
 
 set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
 set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
@@ -24,7 +30,8 @@
 set(CPACK_SOURCE_PACKAGE_FILE_NAME
   "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 set(CPACK_SOURCE_IGNORE_FILES
-  "/build/;/.git/;/.github/;/*.patch;/.bundle/;/_site/;/vendor/;~$;${CPACK_SOURCE_IGNORE_FILES}")
+  "/build/;/test/;/.cache/;/.git/;/.github/;/*.patch;/.bundle/;/_site/;/vendor/;~$;${CPACK_SOURCE_IGNORE_FILES}")
+set(CPACK_PACKAGE_CHECKSUM "SHA256")
 include(CPack)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -32,9 +39,14 @@
 
 message(STATUS "pgagroal ${VERSION_STRING}")
 
+set(check TRUE)
+set(container FALSE)
+
 include(CheckCCompilerFlag)
 include(CheckCSourceCompiles)
+include(CheckIncludeFile)
 include(CheckLinkerFlag)
+include(CheckFunctionExists)
 include(FindPackageHandleStandardArgs)
 include(GNUInstallDirs)
 
@@ -49,7 +61,7 @@
 
 # Check for a supported compiler
 if (NOT CMAKE_C_COMPILER_ID IN_LIST SUPPORTED_COMPILERS)
-   message(FATAL_ERROR "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}")
+  message(FATAL_ERROR "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}")
 endif ()
 
 CHECK_C_COMPILER_FLAG("-std=c17" COMPILER_SUPPORTS_C17)
@@ -57,11 +69,54 @@
   message(FATAL_ERROR "The compiler ${CMAKE_C_COMPILER} has no C17 support. Please use a different C compiler.")
 endif()
 
-find_package(Libev 4.11)
-if (LIBEV_FOUND)
-  message(STATUS "libev found")
-else ()
-  message(FATAL_ERROR "libev needed")
+find_package(Check)
+if (CHECK_FOUND)
+  message(STATUS "check found")
+  add_library(Check::check SHARED IMPORTED)
+  set_target_properties(Check::check PROPERTIES
+    IMPORTED_LOCATION ${CHECK_LIBRARY}
+    INTERFACE_INCLUDE_DIRECTORIES ${CHECK_INCLUDE_DIR})
+else ()
+  message(STATUS "check needed. The testsuite process will be skipped.")
+  set(check FALSE)
+endif()
+
+find_program(DOCKER_EXECUTABLE docker)
+find_program(PODMAN_EXECUTABLE podman)
+if (DOCKER_EXECUTABLE OR PODMAN_EXECUTABLE)
+  set(container TRUE)
+  message(STATUS "Docker or podman found")
+else ()
+  message(STATUS "Docker or podman needed. The test suite will be skipped.")
+endif()
+
+
+find_package(ZLIB)
+if (ZLIB_FOUND)
+  message(STATUS "zlib found")
+else ()
+  message(FATAL_ERROR "zlib needed")
+endif()
+
+find_package(BZip2)
+if (BZIP2_FOUND)
+  message(STATUS "bzip2 found")
+else ()
+  message(FATAL_ERROR "bzip2 needed")
+endif()
+
+find_package(Zstd)
+if (ZSTD_FOUND)
+  message(STATUS "zstd found")
+else ()
+  message(FATAL_ERROR "zstd needed")
+endif()
+
+find_package(Lz4)
+if (LZ4_FOUND)
+  message(STATUS "lz4 found")
+else ()
+  message(FATAL_ERROR "lz4 needed")
 endif()
 
 find_package(OpenSSL)
@@ -78,15 +133,36 @@
   message(FATAL_ERROR "rst2man needed")
 endif()
 
-# search for cJSON library
-# <https://github.com/DaveGamble/cJSON>
-find_package(cJSON)
-if (cJSON_FOUND)
-  message(STATUS "cJSON found version ${CJSON_VERSION}")
-else ()
-  message(FATAL_ERROR "cJSON needed")
-endif()
-
+find_package(THREAD)
+if (THREAD_FOUND)
+  message(STATUS "pthread found")
+else ()
+  message(FATAL_ERROR "pthread needed")
+endif()
+
+if (DOCS)
+  find_package(Pandoc)
+  if (PANDOC_FOUND)
+    message(STATUS "pandoc found")
+  else ()
+    set(DOCS FALSE)
+    message(STATUS "pandoc needed. The documentation will be skipped.")
+  endif()
+
+  find_package(Pdflatex)
+  if (PDFLATEX_FOUND)
+    message(STATUS "pdflatex found")
+  else ()
+    set(DOCS FALSE)
+    message(STATUS "pdflatex needed. The documentation will be skipped.")
+  endif()
+endif()
+
+find_package(Doxygen)
+
+if (DOXYGEN_FOUND)
+  message(status "Doxygen found: ${DOXYGEN_EXECUTABLE}")
+endif()
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
   find_package(Libatomic)
@@ -96,15 +172,29 @@
     message(FATAL_ERROR "libatomic needed")
   endif()
 
+  find_package(Liburing 2.5)
+  if (LIBURING_FOUND)
+    message(STATUS "liburing found")
+  else()
+    message(FATAL_ERROR "liburing needed")
+  endif()
+
   find_package(Systemd)
   if (SYSTEMD_FOUND)
     message(STATUS "systemd found")
   else ()
-    message(FATAL_ERROR "systemd needed")
-  endif()
+  message(STATUS "systemd not found; building without systemd support")
+  endif()
+
+  check_function_exists(epoll_pwait2 HAVE_EPOLL_PWAIT2)
 endif()
 
 file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/")
 
 add_subdirectory(doc)
 add_subdirectory(src)
+if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test")
+  add_subdirectory(test)
+else()
+  message(STATUS "Test directory not found, skipping tests")
+endif()
