=== debian/changelog ===
pgagroal (2.0.0-1) experimental; urgency=medium

  * New upstream version 2.0.0.
  * Drop big-endian patch, rejected upstream.
  * Upload to experimental to check architecture portability.

 -- Christoph Berg <myon@debian.org>  Thu, 29 Jan 2026 13:57:59 +0100
