=== debian/control ===
--- 
+++ 
@@ -7,13 +7,18 @@
 Build-Depends:
  cmake (>= 3.14.0),
  debhelper-compat (= 13),
+ libbz2-dev,
  libcjson-dev,
  libev-dev,
+ liblz4-dev,
  libssl-dev,
  libsystemd-dev,
+ liburing-dev,
+ libzstd-dev,
  postgresql-all,
  python3-docutils,
-Standards-Version: 4.6.1
+ zlib1g-dev,
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/agroal/pgagroal
 Vcs-Browser: https://salsa.debian.org/postgresql/pgagroal
